#include "../../base.shader"

struct VERT_OUTPUT_WALLS
{
	float4 location : POSITION;
	float4 color : COLOR0;
	float2 uv : TEXCOORD0;
	float2 uv2 : TEXCOORD1;
	float2 modUV : TEXCOORD2;
	float modFactor : NORMAL0;
};

struct PIX_INPUT_WALLS
{
	float4 color : COLOR0;
	float2 uv : TEXCOORD0;
	float2 uv2 : TEXCOORD1;
	float2 modUV : TEXCOORD2;
	float modFactor : NORMAL0;
};

float2 _stencilTargetRatio;
float2 _stencilTargetOffset;
VERT_OUTPUT_WALLS vert(in VERT_INPUT_ATLAS input)
{
	VERT_OUTPUT_WALLS output;
	output.location = mul(input.location, _transform);
	output.color = input.color;
	output.uv = getAnimatedUVsLooping(input.animInfo);
	output.modUV = input.modUV;
	output.modFactor = input.modFactor;
	output.uv2.x = (output.location.x + 1) / 2 * _stencilTargetRatio.x + _stencilTargetOffset.x;
	output.uv2.y = (output.location.y - 1) / -2 * _stencilTargetRatio.y + _stencilTargetOffset.y;
	return output;
}

sampler2D _stencilTarget;
float4 _allegianceColor;
PIX_OUTPUT pix(in PIX_INPUT_WALLS input) : COLOR0
{
	float4 pixel = getModulatedColor(input.uv, input.modUV, input.modFactor);
	pixel = swapAllegianceColor(pixel, _allegianceColor);
	pixel.a *= 1 - tex2D(_stencilTarget, input.uv2).a;
	return pixel * input.color * _color;
}